<?php

namespace AMZcockpitDoctrine\Repository;
use AMZcockpitDoctrine\DBAL\Types\FrequencyType;
use AMZcockpitDoctrine\Entity\ComptabilityPurchase;
use AMZcockpitDoctrine\Entity\ComptabilitySell;
use Doctrine\ORM\QueryBuilder;
use AMZcockpitDoctrine\Entity\User;

/**
 * ComptabilitySellRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class ComptabilitySellRepository extends \Doctrine\ORM\EntityRepository
{
    /**
     * @return array
     */
    public function getComptabilitySimplifiedIncome(User $user, $year = null) {
        if(is_null($year)) {
            $from = new \DateTime('first day of this year 00:00:00');
            $to = new \DateTime('last day of this month');
        } else {
            $from = \DateTime::createFromFormat('d/m/Y H:i:s','01/01/'.$year.' 00:00:00');
            $to = \DateTime::createFromFormat('d/m/Y H:i:s','31/12/'.$year.' 23:59:59');
        }
        $mois = [ "Jan", "Fév", "Mar", "Avr", "Mai", "Juin", "Juil", "Aout", "Sep", "Oct", "Nov", "Déc" ];

        /** @var QueryBuilder $qb */
        $qb = $this->createQueryBuilder('p');
        $qb->select('p');
        $qb->where($qb->expr()->eq('p.user',':user'));

        $qb->andWhere($qb->expr()->eq('p.frequency', ':none_frequency'));
        $qb->andWhere(
            $qb->expr()->orX(
                $qb->expr()->andX(
                    $qb->expr()->isNotNull('p.dateEnd'),
                    $qb->expr()->gte('p.dateEnd', ':to')
                ),
                $qb->expr()->gte('p.date', ':from')
            )
        )
        ->setParameter('none_frequency', FrequencyType::NONE )
        ->setParameter('user', $user)
        ->setParameter('from', $from)
        ->setParameter('to', $to);

        $qb->orderBy('p.date','ASC');
        $comptabilitySells = $qb->getQuery()->getResult();
        $return = [];
        foreach ($mois as $index)
            $return[$index] = 0;

        /** @var ComptabilitySell $comptabilitySell */
        foreach ($comptabilitySells as $comptabilitySell) {
            if($comptabilitySell->getFrequency() == FrequencyType::NONE) {
                $monthNumber = $comptabilitySell->getDate()->format('m');
                $return[$mois[$monthNumber-1]] += (float)$comptabilitySell->getAmount();
            } else {
                $maxDate = $comptabilitySell->getDateEnd();
                if($maxDate > $to) {
                    $maxDate = $to;
                    $maxDate->setDate($to->format('Y'), $to->format('m'), $maxDate->format('d'));
                }
                $minDate = $comptabilitySell->getDate();
                if($minDate < $from) {
                    $minDate = $from;
                    $minDate->setDate($from->format('Y'), $from->format('m'), $minDate->format('d'));
                }
                if($comptabilitySell->getFrequency() == FrequencyType::MONTHLY) {
                    while ($minDate <= $maxDate) {
                        $return[$mois[$minDate->format('m')-1]] += (float)$comptabilitySell->getAmount();
                        $minDate->add(new \DateInterval('P1M'));
                    }
                } elseif($comptabilitySell->getFrequency() == FrequencyType::DAILY) {
                    while ($minDate <= $maxDate) {
                        $return[$mois[$minDate->format('m') - 1]] += (float)$comptabilitySell->getAmount();
                        $minDate->add(new \DateInterval('P1D'));
                    }
                } else {
                    $return[$mois[$comptabilitySell->getDate()->format('m')-1]] += (float)$comptabilitySell->getAmount();
                }
            }
        }

        return $return;
    }

    /**
     * @return array
     */
    public function getComptabilityTvaProjection(User $user, $year = null) {
        if(is_null($year)) {
            $from = new \DateTime('first day of this year 00:00:00');
            $to = new \DateTime('last day of this month');
        } else {
            $from = \DateTime::createFromFormat('d/m/Y H:i:s','01/01/'.$year.' 00:00:00');
            $to = \DateTime::createFromFormat('d/m/Y H:i:s','31/12/'.$year.' 23:59:59');
        }
        $mois = [ "Jan", "Fév", "Mar", "Avr", "Mai", "Juin", "Juil", "Aout", "Sep", "Oct", "Nov", "Déc" ];

        /** @var QueryBuilder $qb */
        $qb = $this->createQueryBuilder('p');
        $qb->select('p');
        $qb->where($qb->expr()->eq('p.user',':user'));

        $qb->andWhere($qb->expr()->eq('p.frequency', ':none_frequency'));
        $qb->andWhere(
            $qb->expr()->orX(
                $qb->expr()->andX(
                    $qb->expr()->isNotNull('p.dateEnd'),
                    $qb->expr()->gte('p.dateEnd', ':to')
                ),
                $qb->expr()->gte('p.date', ':from')
            )
        )
            ->setParameter('none_frequency', FrequencyType::NONE )
            ->setParameter('user', $user)
            ->setParameter('from', $from)
            ->setParameter('to', $to);

        $qb->orderBy('p.date','ASC');
        $comptabilitySells = $qb->getQuery()->getResult();

        $return = [];
        foreach ($mois as $index)
            $return[$index] = [
                'amount' => 0,
                'tva' => 0
            ];

        /** @var ComptabilitySell $comptabilitySell */
        foreach ($comptabilitySells as $comptabilitySell) {
            if($comptabilitySell->getFrequency() == FrequencyType::NONE) {
                $monthNumber = $comptabilitySell->getDate()->format('m');
                $return[$mois[$monthNumber-1]]['amount'] += (float)$comptabilitySell->getAmount();
                $return[$mois[$monthNumber-1]]['tva'] += $comptabilitySell->getAmount()/(1+$comptabilitySell->getTva()/100) - $comptabilitySell->getAmount();
            } else {
                $maxDate = $comptabilitySell->getDateEnd();
                if($maxDate > $to) {
                    $maxDate = $to;
                    $maxDate->setDate($to->format('Y'), $to->format('m'), $maxDate->format('d'));
                }
                $minDate = $comptabilitySell->getDate();
                if($minDate < $from) {
                    $minDate = $from;
                    $minDate->setDate($from->format('Y'), $from->format('m'), $minDate->format('d'));
                }
                if($comptabilitySell->getFrequency() == FrequencyType::MONTHLY) {
                    while ($minDate <= $maxDate) {
                        $return[$mois[$minDate->format('m')-1]]['amount'] += (float)$comptabilitySell->getAmount();
                        $return[$mois[$minDate->format('m')-1]]['tva'] += $comptabilitySell->getAmount()/(1+$comptabilitySell->getTva()/100) - $comptabilitySell->getAmount();
                        $minDate->add(new \DateInterval('P1M'));
                    }
                } elseif($comptabilitySell->getFrequency() == FrequencyType::DAILY) {
                    while ($minDate <= $maxDate) {
                        $return[$mois[$minDate->format('m')-1]]['amount'] += (float)$comptabilitySell->getAmount();
                        $return[$mois[$minDate->format('m')-1]]['tva'] += $comptabilitySell->getAmount()/(1+$comptabilitySell->getTva()/100) - $comptabilitySell->getAmount();
                        $minDate->add(new \DateInterval('P1D'));
                    }
                } else {
                    $return[$mois[$comptabilitySell->getDate()->format('m')-1]]['amount'] += (float)$comptabilitySell->getAmount();
                    $return[$mois[$comptabilitySell->getDate()->format('m')-1]]['tva'] += $comptabilitySell->getAmount()/(1+$comptabilitySell->getTva()/100) - $comptabilitySell->getAmount();
                }
            }
        }

        return $return;
    }

    /**
     * @return array
     */
    public function getComptabilityByDate(User $user, $date) {

        $date = \DateTime::createFromFormat('d-m-Y',$date);
        $date->setTime(0, 0, 0);
        /** @var QueryBuilder $qb */
        $qb = $this->createQueryBuilder('p');
        $qb->select('p');
        $qb->where($qb->expr()->eq('p.user',':user'));

        $qb->andWhere($qb->expr()->eq('p.frequency', ':none_frequency'));
        $qb->andWhere($qb->expr()->eq('p.date', ':date'))
        ->setParameter('none_frequency', FrequencyType::NONE )
        ->setParameter('user', $user)
        ->setParameter('date', $date);

        $qb->orderBy('p.date','ASC');
        return $qb->getQuery()->getResult();
    }

    /**
     * @return array
     */
    public function getComptabilitySellLastThreeCompletMonths(User $user) {
        $to = (new \DateTime('first day of this month 00:00:00'))->sub(new \DateInterval('P1D'));
        $from = (new \DateTime('first day of this month 00:00:00'))->sub(new \DateInterval('P4M'));

        /** @var QueryBuilder $qb */
        $qb = $this->createQueryBuilder('p');
        $qb->select('p');
        $qb->where($qb->expr()->eq('p.user',':user'));

        $qb->andWhere($qb->expr()->eq('p.frequency', ':none_frequency'));
        $qb->andWhere(
            $qb->expr()->orX(
                $qb->expr()->andX(
                    $qb->expr()->isNotNull('p.dateEnd'),
                    $qb->expr()->gte('p.dateEnd', ':to')
                ),
                $qb->expr()->gte('p.date', ':from')
            )
        )
        ->setParameter('none_frequency', FrequencyType::NONE )
        ->setParameter('user', $user)
        ->setParameter('from', $from)
        ->setParameter('to', $to);

        $qb->orderBy('p.date','ASC');
        $comptabilitySells = $qb->getQuery()->getResult();

        $return = [];
        /** @var ComptabilitySell $comptabilitySell */
        foreach ($comptabilitySells as $comptabilitySell) {
            if($comptabilitySell->getFrequency() == FrequencyType::NONE) {
                $index = $comptabilitySell->getDate()->format('m/Y');
                if(!isset($return[$index]))
                    $return[$index] = 0;
                $return[$index] += (float)$comptabilitySell->getAmount();
            } else {
                $maxDate = $comptabilitySell->getDateEnd();
                if($maxDate > $to) {
                    $maxDate = $to;
                    $maxDate->setDate($to->format('Y'), $to->format('m'), $maxDate->format('d'));
                }
                $minDate = $comptabilitySell->getDate();
                if($minDate < $from) {
                    $minDate = $from;
                    $minDate->setDate($from->format('Y'), $from->format('m'), $minDate->format('d'));
                }
                if($comptabilitySell->getFrequency() == FrequencyType::MONTHLY) {
                    while ($minDate <= $maxDate) {
                        $year = $minDate->format('Y');
                        $month = $minDate->format('m')-1;
                        if(!isset($return[$month.'/'.$year]))
                            $return[$month.'/'.$year] = 0;
                        $return[$month.'/'.$year] += (float)$comptabilitySell->getAmount();
                        $minDate->add(new \DateInterval('P1M'));
                    }
                } elseif($comptabilitySell->getFrequency() == FrequencyType::DAILY) {
                    while ($minDate <= $maxDate) {
                        $year = $minDate->format('Y');
                        $month = $minDate->format('m')-1;
                        $index = $month.'/'.$year;
                        if(!isset($return[$index]))
                            $return[$index] = 0;
                        $return[$index] += (float)$comptabilitySell->getAmount();
                        $minDate->add(new \DateInterval('P1D'));
                    }
                } else {
                    $month = $comptabilitySell->getDate()->format('m')-1;
                    $year = $comptabilitySell->getDate()->format('Y');
                    $index = $month.'/'.$year;
                    if(!isset($return[$index]))
                        $return[$index] = 0;
                    $return[$index] += (float)$comptabilitySell->getAmount();
                }
            }
        }

        return $return;
    }

    /**
     * @return array
     */
    public function getComptabilityByDateRange(User $user, array $filters, $withDetails = false) {

        if (!empty($filters['from'])) $filters['from']->setTime(0, 0, 0);
        if (!empty($filters['to'])) $filters['to']->setTime(23, 59, 59);

        $from = $filters['from'];
        $to = $filters['to'];
        /** @var QueryBuilder $qb */
        $qb = $this->createQueryBuilder('p');
        $qb->select('p');
        $qb->where($qb->expr()->eq('p.user',':user'));

        $qb->andWhere($qb->expr()->eq('p.frequency', ':none_frequency'));
        $qb->andWhere(
            $qb->expr()->orX(
                $qb->expr()->andX(
                    $qb->expr()->isNotNull('p.dateEnd'),
                    $qb->expr()->gte('p.dateEnd', ':to')
                ),
                $qb->expr()->gte('p.date', ':from')
            )
        )
        ->setParameter('none_frequency', FrequencyType::NONE )
        ->setParameter('user', $user)
        ->setParameter('from', $filters['from'])
        ->setParameter('to', $filters['to']);

        $qb->orderBy('p.date','ASC');
        $comptabilitySells = $qb->getQuery()->getResult();

        $return = [];
        if($withDetails) {
            /** @var ComptabilitySell $comptabilitySell */
            foreach ($comptabilitySells as $comptabilitySell) {
                $return[$comptabilitySell->getDate()->getTimestamp()] = [
                    'purchaseDate' => $comptabilitySell->getDate(),
                    'reference' => $comptabilitySell->getReference(),
                    'amazonOrderId' => null,
                    'buyerName' => $comptabilitySell->getClient()->getName(),
                    'salesChannel' => null,
                    'orderTotal' => $comptabilitySell->getAmount(),
                    'orderFinalTotal' => $comptabilitySell->getAmount(),
                    'currencyCode' => 'EUR',
                ];
            }
            return $return;
        }

        /** @var ComptabilitySell $comptabilitySell */
        foreach ($comptabilitySells as $comptabilitySell) {
            if($comptabilitySell->getFrequency() == FrequencyType::NONE) {
                $index = $comptabilitySell->getDate()->format('d-m-Y');
                if(!isset($return[$index]))
                    $return[$index] = 0;
                $return[$index] += (float)$comptabilitySell->getAmount();
            } else {
                $maxDate = $comptabilitySell->getDateEnd();
                if($maxDate > $to) {
                    $maxDate = $to;
                    $maxDate->setDate($to->format('Y'), $to->format('m'), $maxDate->format('d'));
                }
                $minDate = $comptabilitySell->getDate();
                if($minDate < $from) {
                    $minDate = $from;
                    $minDate->setDate($from->format('Y'), $from->format('m'), $minDate->format('d'));
                }
                if($comptabilitySell->getFrequency() == FrequencyType::MONTHLY) {
                    while ($minDate <= $maxDate) {
                        $year = $minDate->format('Y');
                        $month = $minDate->format('m')-1;
                        if(!isset($return[$month.'/'.$year]))
                            $return[$month.'/'.$year] = 0;
                        $return[$month.'/'.$year] += (float)$comptabilitySell->getAmount();
                        $minDate->add(new \DateInterval('P1M'));
                    }
                } elseif($comptabilitySell->getFrequency() == FrequencyType::DAILY) {
                    while ($minDate <= $maxDate) {
                        $year = $minDate->format('Y');
                        $month = $minDate->format('m')-1;
                        $index = $month.'/'.$year;
                        if(!isset($return[$index]))
                            $return[$index] = 0;
                        $return[$index] += (float)$comptabilitySell->getAmount();
                        $minDate->add(new \DateInterval('P1D'));
                    }
                } else {
                    $day = $comptabilitySell->getDate()->format('d');
                    $month = $comptabilitySell->getDate()->format('m')-1;
                    $year = $comptabilitySell->getDate()->format('Y');
                    $index = $day.'/'.$month.'/'.$year;
                    if(!isset($return[$index]))
                        $return[$index] = 0;
                    $return[$index] += (float)$comptabilitySell->getAmount();
                }
            }
        }
        return $return;
    }
}
